package es.ucm.fdi.grasia.faerie.demos.teacherFinding.consoleApplication;

import java.net.URI;
import java.util.Properties;

import org.apache.felix.scr.annotations.Component;
import org.apache.log4j.Logger;

import es.ucm.fdi.grasia.faerie.core.AbstractContextObserverComponent;
import es.ucm.fdi.grasia.faerie.core.Attribute;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.core.util.Functions;
import es.ucm.fdi.grasia.faerie.demos.talkingAgents.model.MyLocation;
import es.ucm.fdi.grasia.faerie.demos.teacherFinding.model.Teacher;

@Component(inherit = true)
@SuppressWarnings({ "unchecked", "rawtypes" })
public class ConsoleApplication extends AbstractContextObserverComponent {

	private static Properties properties = Functions.obtainProperties("teacherFinding.properties");
	private Teacher juan = null;

	@Override
	public void addMyReferencedEntities() {
		juan = this.addReferencedEntity(new Teacher(URI.create(properties.getProperty("location.url")), URI.
				create("/demos/teacherFinding/"), URI.create("juan")));
	}

	@Override
	public void doActivate() {
		MyLocation teacherLocation = new MyLocation(juan);
		teacherLocation.setRemotelyUpdateable(true);

		teacherLocation = this.contextRequest(teacherLocation);
		this.putObservedElement(teacherLocation);

		Logger.getLogger(this.getClass()).info("My Initial Location: " + teacherLocation);
	}

	@Override
	public void elementUpdated(Attribute att, ContextEvent event) {
		Logger.getLogger(this.getClass()).info("My Location Updated: " + att);
	}
}
